Attribute VB_Name = "APIStuff"
Option Explicit

' The original WindowProc and the subclassed hWnd.
Private m_OldWindowProc As Long
Private m_ParentHwnd As Long
Private m_ChildHwnd As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Const GWL_WNDPROC = (-4)
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

' A header that contains information about notify messages.
Private Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

' Look for WM_SHOWWINDOW.
Public Function NewWindowProc(ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Const WM_NOTIFY = &H4E
Const LVN_FIRST = -100&
Const LVN_BEGINDRAG = (LVN_FIRST - 9)

Dim notify_header As NMHDR

    ' If we're being destroyed,
    ' restore the original WindowProc.
    If msg = WM_NCDESTROY Then
        UninstallWindowProc
    End If

    If msg = WM_NOTIFY Then
        ' Copy lParam into the NMHDR structure.
        MoveMemory notify_header, ByVal lParam, Len(notify_header)

        ' See if the user is starting an item drag.
        If (notify_header.code = LVN_BEGINDRAG) And _
           (notify_header.hwndFrom = m_ChildHwnd) _
        Then
            NewWindowProc = 1
            Exit Function
        End If
    End If

    NewWindowProc = CallWindowProc( _
        m_OldWindowProc, hWnd, msg, wParam, _
        lParam)
End Function

' Install the new WindowProc.
Public Sub InstallWindowProc(ByVal parent_hwnd As Long, ByVal child_hwnd As Long)
    m_ParentHwnd = parent_hwnd
    m_ChildHwnd = child_hwnd

    m_OldWindowProc = SetWindowLong(m_ParentHwnd, _
        GWL_WNDPROC, AddressOf NewWindowProc)
End Sub

' Restore the original WindowProc.
Public Sub UninstallWindowProc()
    SetWindowLong m_ParentHwnd, GWL_WNDPROC, m_OldWindowProc
    m_ParentHwnd = 0
    m_ChildHwnd = 0
End Sub
